/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_POLL
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_poll.m4"
/* This file is part of mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static size_t last_poll_host_loc
#line 17 "bi_poll.m4"
;
static size_t last_poll_send_loc
#line 18 "bi_poll.m4"
;
static size_t last_poll_recv_loc
#line 19 "bi_poll.m4"
;
static size_t cache_used_loc
#line 20 "bi_poll.m4"
;

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	
#line 27
{ size_t off;
#line 27
  if (host_addr)
#line 27
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(host_addr) + 1)), host_addr);
#line 27
  else
#line 27
     off = 0;
#line 27
  *env_data_ref(env, last_poll_host_loc) = (STKVAL) (off); }
#line 27
;
	
#line 28
{ size_t off;
#line 28
  if (send)
#line 28
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(send) + 1)), send);
#line 28
  else
#line 28
     off = 0;
#line 28
  *env_data_ref(env, last_poll_send_loc) = (STKVAL) (off); }
#line 28
;
	
#line 29
{ size_t off;
#line 29
  if (recv)
#line 29
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(recv) + 1)), recv);
#line 29
  else
#line 29
     off = 0;
#line 29
  *env_data_ref(env, last_poll_recv_loc) = (STKVAL) (off); }
#line 29
;
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_data_ref(env, cache_used_loc) = (STKVAL) (value);
}


void
#line 39
bi_stdpoll(eval_environ_t env)
#line 39

#line 39 "bi_poll.m4"
{
#line 39
	
#line 39

#line 39

#line 39
char * email = (char *) get_string_arg(env, 0);
#line 39
        char * ehlo = (char *) get_string_arg(env, 1);
#line 39
        char * mailfrom = (char *) get_string_arg(env, 2);
#line 39
        
#line 39
        adjust_stack(env, 3);
#line 39

#line 39
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 39
		prog_trace(env, "stdpoll %s %s %s",email, ehlo, mailfrom);;
#line 39

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 49
			env_throw_bi(env, rc, "stdpoll", _("Unhandled exception %s"),mf_status_str(rc))
;
			
	
#line 52
do {
#line 52
  push(env, (STKVAL) (rc));
#line 52
  return;
#line 52
} while (0);	
}
}

void
#line 56
bi_strictpoll(eval_environ_t env)
#line 56

#line 56 "bi_poll.m4"
{
#line 56
	
#line 56

#line 56

#line 56
char * host = (char *) get_string_arg(env, 0);
#line 56
        char * email = (char *) get_string_arg(env, 1);
#line 56
        char * ehlo = (char *) get_string_arg(env, 2);
#line 56
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 56
        
#line 56
        adjust_stack(env, 4);
#line 56

#line 56
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 56
		prog_trace(env, "strictpoll %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 69
			env_throw_bi(env, rc, "strictpoll", _("Unhandled exception %s"),mf_status_str(rc))
;
	
	
#line 72
do {
#line 72
  push(env, (STKVAL) (rc));
#line 72
  return;
#line 72
} while (0);	
}
}

void
#line 76
bi__pollhost(eval_environ_t env)
#line 76

#line 76 "bi_poll.m4"
{
#line 76
	
#line 76

#line 76

#line 76
char * host = (char *) get_string_arg(env, 0);
#line 76
        char * email = (char *) get_string_arg(env, 1);
#line 76
        char * ehlo = (char *) get_string_arg(env, 2);
#line 76
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 76
        
#line 76
        adjust_stack(env, 4);
#line 76

#line 76
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 76
		prog_trace(env, "_pollhost %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

		if (!(mf_resolved(rc)))
#line 90
			env_throw_bi(env, rc, "_pollhost", _("Unhandled exception %s"),mf_status_str(rc))
;
	
	
#line 93
do {
#line 93
  push(env, (STKVAL) (rc));
#line 93
  return;
#line 93
} while (0);	
}
}

void
#line 97
bi__pollmx(eval_environ_t env)
#line 97

#line 97 "bi_poll.m4"
{
#line 97
	
#line 97

#line 97

#line 97
char * domain = (char *) get_string_arg(env, 0);
#line 97
        char * email = (char *) get_string_arg(env, 1);
#line 97
        char * ehlo = (char *) get_string_arg(env, 2);
#line 97
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 97
        
#line 97
        adjust_stack(env, 4);
#line 97

#line 97
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 97
		prog_trace(env, "_pollmx %s %s %s %s",domain, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

		if (!(mf_resolved(rc)))
#line 110
			env_throw_bi(env, rc, "_pollmx", _("Unhandled exception %s"),mf_status_str(rc))
;

	
#line 113
do {
#line 113
  push(env, (STKVAL) (rc));
#line 113
  return;
#line 113
} while (0);	
}
}


#line 117
void
#line 117
poll_init_builtin()
#line 117
{
#line 117
	#line 17 "bi_poll.m4"
	last_poll_host_loc = builtin_variable_install("last_poll_host", dtype_string, VAR_VOLATILE)->off;
#line 18 "bi_poll.m4"
	last_poll_send_loc = builtin_variable_install("last_poll_send", dtype_string, VAR_VOLATILE)->off;
#line 19 "bi_poll.m4"
	last_poll_recv_loc = builtin_variable_install("last_poll_recv", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_poll.m4"
	cache_used_loc = builtin_variable_install("cache_used", dtype_number, VAR_VOLATILE)->off;
#line 39 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, 0, dtype_number, 3, 0, 0, dtype_string, dtype_string, dtype_string);
#line 56 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 76 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 97 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);

#line 117 "bi_poll.m4"
		
#line 117
}
#line 547 "../src/snarf.m4"

#line 547

