/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_SPF
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_spf.m4"
/* This file is part of mailfromd.             -*- c -*-
   Copyright (C) 2007 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "spf.h"

static size_t spf_explanation_loc
#line 19 "bi_spf.m4"
;
static size_t spf_mechanism_loc
#line 20 "bi_spf.m4"
;
static size_t spf_ttl_loc
#line 21 "bi_spf.m4"
;
static size_t spf_explanation_prefix_loc
#line 22 "bi_spf.m4"
;
       
static void
update_spf_vars(eval_environ_t env, spf_answer_t *ans)
{
	
#line 27
{ size_t off;
#line 27
  if (ans->exp_text)
#line 27
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(ans->exp_text) + 1)), ans->exp_text);
#line 27
  else
#line 27
     off = 0;
#line 27
  *env_data_ref(env, spf_explanation_loc) = (STKVAL) (off); }
#line 27
;
	
#line 28
{ size_t off;
#line 28
  if (ans->mech)
#line 28
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(ans->mech) + 1)), ans->mech);
#line 28
  else
#line 28
     off = 0;
#line 28
  *env_data_ref(env, spf_mechanism_loc) = (STKVAL) (off); }
#line 28
;
	*env_data_ref(env, spf_ttl_loc) = (STKVAL) (ans->ttl);
}

void
#line 32
bi_spf_check_host(eval_environ_t env)
#line 32

#line 32 "bi_spf.m4"
{
#line 32
	
#line 32

#line 32

#line 32
char * ip = (char *) get_string_arg(env, 0);
#line 32
        char * domain = (char *) get_string_arg(env, 1);
#line 32
        char * sender = (char *) get_string_arg(env, 2);
#line 32
        char * helo_domain = (char *) get_string_arg(env, 3);
#line 32
        char * my_domain = (char *) get_string_arg(env, 4);
#line 32
        
#line 32
        adjust_stack(env, 5);
#line 32

#line 32
	if (prog_trace_option & BUILTIN_MASK_spf)
#line 32
		prog_trace(env, "spf_check_host %s %s %s %s %s",ip, domain, sender, helo_domain, my_domain);;

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_check_host(&q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 48
do {
#line 48
  push(env, (STKVAL) (res));
#line 48
  return;
#line 48
} while (0);
}
}

void
#line 52
bi_spf_test_record(eval_environ_t env)
#line 52

#line 52 "bi_spf.m4"
{
#line 52
	
#line 52

#line 52

#line 52
char * record = (char *) get_string_arg(env, 0);
#line 52
        char * ip = (char *) get_string_arg(env, 1);
#line 52
        char * domain = (char *) get_string_arg(env, 2);
#line 52
        char * sender = (char *) get_string_arg(env, 3);
#line 52
        char * helo_domain = (char *) get_string_arg(env, 4);
#line 52
        char * my_domain = (char *) get_string_arg(env, 5);
#line 52
        
#line 52
        adjust_stack(env, 6);
#line 52

#line 52
	if (prog_trace_option & BUILTIN_MASK_spf)
#line 52
		prog_trace(env, "spf_test_record %s %s %s %s %s %s",record, ip, domain, sender, helo_domain, my_domain);;
#line 54

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_test_record(record, &q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 69
do {
#line 69
  push(env, (STKVAL) (res));
#line 69
  return;
#line 69
} while (0);
}
}


#line 73
void
#line 73
spf_init_builtin()
#line 73
{
#line 73
	#line 19 "bi_spf.m4"
	spf_explanation_loc = builtin_variable_install("spf_explanation", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_spf.m4"
	spf_mechanism_loc = builtin_variable_install("spf_mechanism", dtype_string, VAR_VOLATILE)->off;
#line 21 "bi_spf.m4"
	spf_ttl_loc = builtin_variable_install("spf_ttl", dtype_number, VAR_VOLATILE)->off;
#line 22 "bi_spf.m4"
	spf_explanation_prefix_loc = builtin_variable_install("spf_explanation_prefix", dtype_string, VAR_VOLATILE)->off;
#line 32 "bi_spf.m4"
va_builtin_install_ex("spf_check_host", bi_spf_check_host, 0, 0, dtype_number, 5, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);
#line 52 "bi_spf.m4"
va_builtin_install_ex("spf_test_record", bi_spf_test_record, 0, 0, dtype_number, 6, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);

#line 73 "bi_spf.m4"
		
#line 73
}
#line 547 "../src/snarf.m4"

#line 547

